// Apply values from getFMstorage response to input .value elemets
//
function input_complex(nme, res, defval, vtype) {
         setTimeout(() => {
         var newnme = document.querySelector(`#${nme}`);
         if (vtype == "value") {newnme.value = res || `${defval}`;} else {
         if (res !== "undefined") {newnme.checked = res} else {newnme.checked = defval};};
         var event = new Event('change');
         newnme.dispatchEvent(event);
  }, 380)
}

//  indexDB part
//
	const DB_NAME = 'SCFcache';
	const DB_VERSION = 2; // Use a long long for this value (don't use a float)
	const DB_STORE_NAME = 'fotos';

	var db;
	var passed_item;
  // Used to keep track of which view is displayed to avoid uselessly reloading it
  //var current_view_pub_key;
	var photos_count = 1;
    
  function openDb() {
    console.log("openDb ...");
    var req = indexedDB.open(DB_NAME, DB_VERSION);
    req.onsuccess = function (evt) {
      // Equal to: db = req.result;
      db = this.result;
      console.log("openDb DONE");
    };
    req.onerror = function (evt) {
      console.error("openDb err:", evt.target.errorCode);
    };

    req.onupgradeneeded = function (evt) {
      console.log("openDb.onupgradeneeded");
      var store = evt.currentTarget.result.createObjectStore(
        DB_STORE_NAME, { keyPath: 'id', autoIncrement: true });
      store.createIndex('name', 'name', { unique: true });
    };
  }

  function getObjectStore(store_name, mode) {
    var tx = db.transaction(store_name, mode);
    return tx.objectStore(store_name);
  }

  function clearObjectStore() {
    var store = getObjectStore(DB_STORE_NAME, 'readwrite');
    var req = store.clear();
    req.onsuccess = function(evt) {
      displayActionSuccess("Store cleared");
      photos_count = 1;
    };
    req.onerror = function (evt) {
      console.error("clearObjectStore:", evt.target.errorCode);
      displayActionFailure(this.error);
    };
  }

  function addPublication(collectedBlobs) {
    var store = getObjectStore(DB_STORE_NAME, 'readwrite');
    for (const item of collectedBlobs) {
		var nme = item.name.replace(/\.[^/.]+$/, "");    
		var obj = { name: nme };
		obj.blob = item;
		var req;
		try {
			req = store.add(obj);
		} catch (e) {
      if (e.name == 'DataCloneError')
        displayActionFailure("This engine doesn't know how to clone a Blob, " +
                             "use Firefox");
      throw e;
    }
    req.onsuccess = function (evt) {
      console.log("Insertion in DB successful");
      displayActionSuccess();
      passed_item = item.name;
      photos_count++;
      if (photos_count == collectedBlobs.length)
      {browser.storage.local.set({exist_db: "yes"})};
    };
    req.onerror = function() {
      console.error("addPublication error", this.error);
      displayActionFailure(this.error);
    };
  }
 }
	
  function displayActionSuccess(msg) {
    msg = typeof msg != 'undefined' ? "Success: " + msg : "Success";
    mesg.innerHTML = '<span style="color:green">' + msg + ' (' + photos_count + ' photo)</span>';
  }
  function displayActionFailure(msg) {
    msg = typeof msg != 'undefined' ? "Failure: " + msg : "Failure";
    mesg.innerHTML = '<span style="color:red"> Cache is NOT created. Broken after \"' + passed_item + '\" processing. Check photo file duplicates.</span>';
  }

// Get value for variable "sname" from storage or assign default value in "defval"
//
const getFMstorageComplex = async(sname, defval, vtype) => {
      var reslt  = await browser.storage.local.get(sname);
      var reslt2 =Object.values(reslt)[0];
      input_complex(sname, reslt2, defval, vtype);
};

document.addEventListener("DOMContentLoaded", function(event) {

// Define variables for input elements and styles, load values from local
// storage or assign default value if absent in storage
//
var ab_prio          = document.querySelector("#ab_prio");
var local_prio       = document.querySelector("#local_prio");
var margin_width     = document.querySelector("#margin_width");
var icon_heght       = document.querySelector("#icon_height");
var icon_space       = document.querySelector("#icon_space");
var nophoto_dark     = document.querySelector("#nophoto_dark");
var nophoto          = document.querySelector("#nophoto");
var nophoto_light    = document.querySelector("#nophoto_light");
var skip_nofoto      = document.querySelector("#skip_nofoto");
var popup_height     = document.querySelector("#popup_height");
var icon_radius      = document.querySelector("#icon_radius");
var popup_backgnd    = document.querySelector("#popup_backgnd");
var popup_font_size  = document.querySelector("#popup_font_size");
var popup_font_color = document.querySelector("#popup_font_color");
var popup_radius     = document.querySelector("#popup_radius");
var popup_bradius    = document.querySelector("#popup_bradius");
var tooltip_width    = document.querySelector("#tooltip_width");
var grid_backgnd     = document.querySelector("#grid_backgnd");
var use_bkgnd        = document.querySelector("#use_bkgnd");
var pinned           = document.querySelector("#pinned");
var max_icons        = document.querySelector("#max_icons");
var pinbtn           = document.querySelector("#pinButton");
var gridop           = document.querySelector("#notification");
var fle_pub 		 = document.querySelector("#getDr");
var mesg 			 = document.querySelector("#mesg");


getFMstorageComplex("ab_prio", true, "radio");
getFMstorageComplex("local_prio", false, "radio");
getFMstorageComplex("margin_width", "30", "value");
getFMstorageComplex("icon_height", "48", "value");
getFMstorageComplex("icon_space", "4", "value");
getFMstorageComplex("icon_radius", "8", "value");
getFMstorageComplex("nophoto_dark", false, "radio");
getFMstorageComplex("nophoto", true, "radio");
getFMstorageComplex("nophoto_light", false, "radio");
getFMstorageComplex("skip_nofoto", false, "radio");
getFMstorageComplex("popup_height", "250", "value");
getFMstorageComplex("popup_backgnd", "#808080", "value");
getFMstorageComplex("popup_font_size", "14", "value");
getFMstorageComplex("popup_font_color", "#ffffff", "value");
getFMstorageComplex("popup_radius", "8", "value");
getFMstorageComplex("popup_bradius", "8", "value");
getFMstorageComplex("tooltip_width", "210", "value");
getFMstorageComplex("grid_backgnd", "#eeeeee", "value");
getFMstorageComplex("use_bkgnd", true, "radio");
getFMstorageComplex("pinned", true, "radio");
getFMstorageComplex("max_icons", "50", "value");


// Add listenes to inputs for dynamic change of photo grid
//
addEventListener("change", function() {console.log("listener ab_prio")});
ab_prio.onchange = () => {console.log('onchange callback ab_prio')};

addEventListener("change", function() {console.log("listener local_prio")});
local_prio.onchange = () => {console.log('onchange callback local_prio')};

margin_width.addEventListener("change", function() {
    var lmargin = document.querySelectorAll(".left_margin")[0];
    lmargin.style.width = "" + margin_width.value + "px";
  });
margin_width.onchange = () => {console.log('onchange callback margin_width')};

icon_height.addEventListener("change", function() {
    var icon_h = document.querySelectorAll(".icon");
    for (let ic=0; ic<icon_h.length; ic++) {
      icon_h[ic].style.height = ""+icon_height.value+"px";
    }
  });
icon_height.onchange = () => {console.log('onchange callback icon_height')}

icon_space.addEventListener("change", function() {
   var spacrv = document.querySelectorAll(".spacr");
   for (let a=0; a<spacrv.length; a++) {
      spacrv[a].style.width = "" + icon_space.value + "px";
     }
  });
icon_space.onchange = () => {console.log('onchange callback icon_space')}

icon_radius.addEventListener("change", function() {
    var icon_rad = document.querySelectorAll(".icon");
    for (let ir=0; ir<icon_rad.length; ir++) {
      icon_rad[ir].style.borderRadius = ""+icon_radius.value+"px";
    }
  });
icon_radius.onchange = () => {console.log('onchange callback icon_radius')}

nophoto_dark.addEventListener("change", function() {
    if (nophoto_dark.checked != false) {
    var icon_nophoto_drk = document.getElementById("icon_nophoto");
    icon_nophoto_drk.setAttribute("src", "nophoto_dark.png");
    icon_nophoto_drk.removeAttribute("hidden");
    var popup_nophoto_drk = document.getElementById("popup_nophoto");
    popup_nophoto_drk.setAttribute("src", "nophoto_dark.png");
   }
  });
nophoto_dark.onchange = () => {console.log('onchange callback nophoto_dark')}

nophoto.addEventListener("change", function() {
    if (nophoto.checked != false) {
    var icon_nophoto = document.getElementById("icon_nophoto");
    icon_nophoto.setAttribute("src", "nophoto.png");
    icon_nophoto.removeAttribute("hidden");
    var popup_nophoto = document.getElementById("popup_nophoto");
    popup_nophoto.setAttribute("src", "nophoto.png");
    }
  });
nophoto.onchange = () => {console.log('onchange callback nophoto')}

nophoto_light.addEventListener("change", function() {
    if (nophoto_light.checked != false) {
    var icon_nophoto_lght = document.getElementById("icon_nophoto");
    icon_nophoto_lght.setAttribute("src", "nophoto_light.png");
    icon_nophoto_lght.removeAttribute("hidden");
    var popup_nophoto_lght = document.getElementById("popup_nophoto");
    popup_nophoto_lght.setAttribute("src", "nophoto_light.png");
   }
  });
nophoto_light.onchange = () => {console.log('onchange callback nophoto_light')}


skip_nofoto.addEventListener("change", function() {
    if (skip_nofoto.checked != false) {
    var icon_nophoto_skip = document.getElementById("icon_nophoto");
    icon_nophoto_skip.setAttribute("hidden", true);
   }
  });
skip_nofoto.onchange = () => {console.log('onchange callback nophoto_skip')}


popup_height.addEventListener("change", function() {
    var popup_h = document.querySelectorAll(".popup");
    for (let ip=0; ip<popup_h.length; ip++) {
      popup_h[ip].style.height = ""+popup_height.value+"px";
    }
  });
popup_height.onchange = () => {console.log('onchange callback popup_height')}

popup_backgnd.addEventListener("change", function() {
    var popup_bkg = document.querySelectorAll(".tooltiptext");
    for (let bg=0; bg<popup_bkg.length; bg++) {
      popup_bkg[bg].style.backgroundColor = popup_backgnd.value;
    }
  });
popup_backgnd.onchange = () => {console.log('onchange callback popup_backgnd')}

popup_font_size.addEventListener("change", function() {
    var fnt_s = document.querySelectorAll(".tooltiptext");
    for (let fs=0; fs<fnt_s.length; fs++) {
      fnt_s[fs].style.fontSize = popup_font_size.value;
    }
  });
popup_font_size.onchange = () => {console.log('onchange callback popup_font_size')}

popup_font_color.addEventListener("change", function() {
    var popup_fnt = document.querySelectorAll(".tooltiptext");
    for (let ib=0; ib<popup_fnt.length; ib++) {
      popup_fnt[ib].style.color = popup_font_color.value;
    }
  });
popup_font_color.onchange = () => {console.log('onchange callback popup_font_color')}

popup_radius.addEventListener("change", function() {
    var popup_rad = document.querySelectorAll(".popup");
    for (let pr=0; pr<popup_rad.length; pr++) {
      popup_rad[pr].style.borderRadius = ""+popup_radius.value+"px";
    }
  });
popup_radius.onchange = () => {console.log('onchange callback popup_radius')}

popup_bradius.addEventListener("change", function() {
    var popup_brad = document.querySelectorAll(".tooltiptext");
    for (let pbr=0; pbr<popup_brad.length; pbr++) {
      popup_brad[pbr].style.borderRadius = ""+popup_bradius.value+"px";
    }
  });
popup_bradius.onchange = () => {console.log('onchange callback popup_bradius')}

tooltip_width.addEventListener("change", function() {
    var tip_wdth = document.querySelectorAll(".tooltiptext");
    for (let tw=0; tw<tip_wdth.length; tw++) {
      tip_wdth[tw].style.width = ""+tooltip_width.value+"px";
    }
  });
tooltip_width.onchange = () => {console.log('onchange callback tooltip_width')}

addEventListener("change", function() {console.log("listener use_bkgnd")});
use_bkgnd.onchange = () => {console.log('onchange callback use_bkgnd')};

function gridStyle() {
   if (pinned.checked == true) {
       var pinstyle = "position:sticky;";} else {var pinstyle = "position:static;"};
   if (use_bkgnd.checked == false) {
       var bkgstyle = "";} else {var bkgstyle = "background-color:"+grid_backgnd.value+";";}
   gridop.setAttribute("style", `${pinstyle}${bkgstyle}`)
};

pinned.addEventListener("change", function() {
   if (pinned.checked == true) {pinbtn.innerText = "un-Pin";}else {pinbtn.innerText = "Pin"};
   gridStyle();
  });
pinned.onchange = () => {console.log('onchange callback pinned')}

pinButton.addEventListener("click", function() {
    if (pinbtn.innerText == "un-Pin") {pinbtn.innerText = "Pin";}
    else {pinbtn.innerText = "un-Pin";};
    var attrib = gridop.getAttribute("style");
    var attrtrm = attrib.slice(0,15)
    if ( attrtrm == "position:sticky") {
       var attres = attrib.replace("sticky","static");
       gridop.setAttribute("style", attres);
     }
    else {
       var attres = attrib.replace("static","sticky");
       gridop.setAttribute("style", attres);
       };
  });

grid_backgnd.addEventListener("change", function() {
     gridStyle();
  });
grid_backgnd.onchange = () => {console.log('onchange callback grid_backgnd')}

addEventListener("change", function() {console.log("listener max_icons")});
max_icons.onchange = () => {console.log('onchange callback max_icons')};

use_bkgnd.addEventListener("change", function() {
     gridStyle();
  });
use_bkgnd.onchange = () => {console.log('onchange callback use_bkgnd')}

// Save Prefs on button click
var set_props = document.getElementById("save_sets");
set_props.addEventListener("click", function() {
    let SCFcurrent = {
      ab_prio:          ab_prio.checked,
      local_prio:       local_prio.checked,
      margin_width:     margin_width.value,
      icon_height:      icon_height.value,
      icon_space:       icon_space.value,
      nophoto_dark:     nophoto_dark.checked,
      nophoto:          nophoto.checked,
      nophoto_light:    nophoto_light.checked,
      skip_nofoto:	    skip_nofoto.checked,
      popup_height:     popup_height.value,
      icon_radius:      icon_radius.value,
      popup_backgnd:    popup_backgnd.value,
      popup_font_size:  popup_font_size.value,
      popup_font_color: popup_font_color.value,
      popup_radius:     popup_radius.value,
      popup_bradius:    popup_bradius.value,
      tooltip_width:    tooltip_width.value,
      grid_backgnd:     grid_backgnd.value,
      use_bkgnd:        use_bkgnd.checked,
      pinned:           pinned.checked,
      max_icons:        max_icons.value
    };
   var keyArr =[];
   for (let [key, prefset] of Object.entries(SCFcurrent)) {
       if (prefset === "" && prefset !== false) {keyArr.push(key);
         };
   };
   nosave:
     if (keyArr.length > 0)   {
     document.getElementById("warn_s").innerHTML = "NOT saved - enter value!";
     console.log("Not Saved");
     keyArr.forEach(element => document.getElementById(element).style.backgroundColor = "#ffc2c2");
     break nosave
   }
   else {browser.storage.local.set(SCFcurrent); location.reload();};
  });

  var reset_sets = document.getElementById("reset_sets");
  reset_sets.addEventListener("click", function() {
   browser.storage.local.clear();
   location.reload();
  });
  
   fle_pub.addEventListener("change", handleFiles, false);
	async function handleFiles() {
		var reslt  = await browser.storage.local.get({exist_db:33});
        var reslt2 = reslt.exist_db;
        if (reslt2 == "yes") {clearObjectStore();};
		const selected_files = this.files;
		if (selected_files) {
			addPublication(selected_files);
		}
	};
openDb();
})

